' ##############################################################################
' Declarations
' ##############################################################################
const sqlite3_ok		= 0	' successful result
' I erased other error constants - you can find it on "www.sqlite.org"

if fileexists("sqlite3.dll") = 0 then
	showmessage "Chba kninica SQLite3.dll, ktor je potrebn pre obsluhu programu." + crlf + _
		"Kontaktujte autora programu, alebo si kninicu stiahnite z adresy:" + crlf + _
		"http://www.sqlite.org/download.html" + crlf + crlf + _
		"Program bude teraz ukonen..."
	application.terminate
end if

dim dbName as String, dbHandle as Long, separ as String, query as string
separ = "|"

declare function sqlite3_libversion LIB "sqlite3.dll" alias "sqlite3_libversion" () as long
declare function sqlite3_open LIB "sqlite3.dll" alias "sqlite3_open" _
	(filename as long, byref dbHandle as long) as long
' declare function sqlite3_open LIB "sqlite3.dll" alias "sqlite3_open" _
' 	(byref filename as string, byref db as long) as long
declare function sqlite3_close LIB "sqlite3.dll" alias "sqlite3_close" (db as long) as long
declare function sqlite3_exec LIB "sqlite3.dll" alias "sqlite3_exec" _
	(db as long, byref sql as string, pCallback as long, pUserData as long, ppErrMsg as long) as long
	
' ------------------------------------------------------------------------------
declare function sqlite3_get_table LIB "sqlite3.dll" alias "sqlite3_get_table" _
	(db as long, query as Long, lpTable as long, nRow as long, nColumn as long, lpErrMsg as long) as long
' ------------------------------------------------------------------------------
declare function sqlite3_free_table LIB "sqlite3.dll" alias "sqlite3_free_table" _
	(lpTable as long) as long
declare function sqlite3_last_insert_rowid lib "sqlite3.dll" alias "sqlite3_last_insert_rowid" _
		(byval db as long) as long
declare function sqlite3_prepare lib "sqlite3.dll" alias "sqlite3_prepare" _
		( byval DBHandle as long, SQL as String, byval iLen as long,  ppVMM as long, pzTail as string ) as long
declare function sqlite3_finalize lib "sqlite3.dll" alias "sqlite3_finalize" _
		( byval pStmt as long ) as long


' ----- my own SQLite3 functions for better manipulating with data ---------
	declare function SQL3_LibVersion as String
	declare function SQL3_GetTable as String
	declare function SQL3_ErrCode (error as word) as String
	declare function SQL3_FillListView (Sender as QStringList, ListView as QListView) as String

' ------------------------------------------------------------------------------
function SQL3_libversion
	dim bChar			as byte
	dim iCounter		as byte
	dim ptr_version		as long
	dim str_version		as string
		str_version = ""

	ptr_version = sqlite3_libversion()
	iCounter = 0
	DO
        MemCpy (varptr(bChar), ptr_version + iCounter, 1)
		IF (bChar = 0) THEN EXIT DO
	    str_version = str_version + chr$(bChar)
        iCounter++
    LOOP
	SQL3_libversion = str_version
end function

' ------------------------------------------------------------------------------
function SQL3_GetTable

	dim result1	as word
	dim result2	as word
	dim nrows	as long
	dim ncolumns as long
	dim perrmsg	as long
	dim lptable	as long
	dim lerrmsg	as long
	dim ipos	as integer
	dim bcar	as byte
	dim litems	as long
	dim prow	as long
	dim pcol	as long
	dim sversion as string
	dim icounter as long
	dim StringList as QStringList
		StringList.Clear

	result1 = sqlite3_open (VARPTR(dbName), dbHandle)
	if result1 = sqlite3_ok then
		result2 = sqlite3_get_table (dbHandle, VARPTR(query), VARPTR(lptable), VARPTR(nrows), VARPTR(ncolumns), VARPTR(perrmsg))
		
		if result2 = sqlite3_ok then
			for litems = 0 to (nrows * ncolumns) + (ncolumns - 1)
				pcol = (litems mod ncolumns)
				if pcol = 0 then sversion = ""
				memcpy varptr(prow), lptable + (4 * litems), 4
				icounter = 0

				do
					memcpy varptr(bcar), prow + icounter, 1
					if (bcar = 0) then exit do
					sversion = sversion + chr$(bcar)
					icounter = icounter + 1
				loop

				if pcol = ncolumns - 1 and bcar = 0 then
					stringlist.additems sversion
				else:
					sversion = sversion + separ
				end if
			next

			sqlite3_free_table varptr(lptable)
		else
			showmessage SQL3_errCode(lerrmsg)
		end if
		SQL3_gettable = stringList.text
	else
		showmessage SQL3_errCode(lerrmsg)
	end if
	sqlite3_close (dbHandle)
end function

' ------------------------------------------------------------------------------
function SQL3_errcode
	' others error numbers are missing (could someone help me with testing?)
	dim str_temp as String
	dim Error as Word
	Select case Error
		Case 1: str_Temp = "neznma SQL syntax alebo chbajca databza..."
		Case 14: str_Temp = "nemono otvori databzov sbor..."
		Case 19: str_Temp = "duplicitn nzov poloky poa..."
		Case Else:
			str_Temp = "neznma chyba - prosm popte ju autorovi bliie (iss@post.sk)"
	end Select
	SQL3_errCode = "(" + str$(Error) + ") - chyba SQLite3 databzy. Mon chyba: " _
		+ crlf +  str_Temp
end function

' ------------------------------------------------------------------------------
sub SQL3_FillListView
	dim I as Integer, J as Byte, Record as QStringList
	ListView.clear
	' Fill items on listview
	For I = 1 to Sender.ItemCount - 1
		Record.Clear
		Record.Parse (Sender.Item(I), separ)
		ListView.addItems Record.Item(0)
		For J = 1 to Record.ItemCount - 1
			ListView.addSubItem (I-1, Record.Item(J))
		Next
	Next
end sub
